<script lang="ts" setup>
import { type Ref, inject, ref, watch } from 'vue'
import { useReceiptStore } from '@/stores/receipt'
import { usePaymentStore } from '@/stores/payment'
import ReceiptDialog from './ReceiptDialog.vue'

const receiptStore = useReceiptStore()
const paymentStore = usePaymentStore()
const showReceipt = function () {
  receiptStore.showReceiptDialog()
}

const clearReceipt = function () {
  receiptStore.clear()
}
const cash = ref(0)
const cashValidationMessage = ref('')
const cashdialog = inject<Ref<boolean>>('paymentDialog')

watch(cash, (newValue) => {
  paymentStore.cash = newValue
  if (newValue < receiptStore.receipt?.total) {
    cashValidationMessage.value = 'Please enter an amount greater than the total price.'
  } else {
    cashValidationMessage.value = ''
  }
})
const handlePaymentSuccess = () => {
  if (cashdialog !== undefined) {
    receiptStore.receipt.receivedAmount = cash.value
    cashdialog.value = false
    receiptStore.calReceipt()
    showReceipt()
  }
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="cashdialog" persistent width="1024">
      <v-card>
        <v-card-title>
          <span class="text-h5">Cash</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Enter the cash received" v-model="cash"></v-text-field>
                <v-alert v-if="cashValidationMessage" type="error">{{
                  cashValidationMessage
                }}</v-alert>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="cashdialog = false"> Cancel </v-btn>
          <v-btn
            color="blue-darken-1"
            variant="text"
            @click="handlePaymentSuccess"
            :disabled="cashValidationMessage !== ''"
          >
            Payment successful
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <ReceiptDialog></ReceiptDialog>
</template>
